/****************************************************************************/
/*                                                                          */
/* ENQHELP.C                                                                */
/*                                                                          */
/*                                                                          */
/****************************************************************************/
/*----------------------------- include files ------------------------------*/
#include <stdio.h>
#include <ctype.h>
#include "t.h"

/*------------------------------- prototypes -------------------------------*/
void main( int argc, char *argv[] );
int get_screen_text(char *buffer, int max_len);
void abort_help( void );
void init_help_video( void );

/*********/
/* ~main */
/*       ********************************************************************/
/* Usage: ENQHELP filename get_mode search_str sx sy ex ey                  */
/****************************************************************************/
void main( int argc, char *argv[] )
{
  int  sx, sy, ex, ey, mode;
  char fname[133], search[133];

  strcpy(search, "");

  if ( argc < 2 )
    strcpy(fname,"UW_HELP0.HLP");
  else if ( argv[1][0] == '?' )
    abort_help();
  else
    strcpy(fname,argv[1]);

  if ( argc < 3 )
    mode = 0;
  else
    mode = atoi(argv[2]);

  if (argc > 3)
    if (strcmp(argv[3], "0"))
      strcpy(search, argv[3] );

  if( argc >= 7 )
  {
    sx   = atoi(argv[4]);
    sy   = atoi(argv[5]);
    ex   = atoi(argv[6]);
    ey   = atoi(argv[7]);
  }else
    sx = 0, ex = 79, sy = 0, ey = 24;
  init_help_video();
  init_clock(0x3333);
  init_mouse();
  csr_hide();
  m_show();
  if( mode && (get_screen_text(search,80) > 0) )
    tui_help(sx, sy, ex, ey, fname, search, 1);
  else
    tui_help(sx, sy, ex, ey, fname, search, 0);
  m_hide();
  end_mouse();
  end_clock();
  csr_show();
  exit(0);
}
/*** end of main ***/

/********************/
/* ~get_screen_text */
/*                  *********************************************************/
/****************************************************************************/
char UW_FAR *Lcol  = (char UW_FAR *) (UW_MK_FP(0x0000,0x0200));
char UW_FAR *Lrow  = (char UW_FAR *) (UW_MK_FP(0x0000,0x0201));
char UW_FAR *Lstat = (char UW_FAR *) (UW_MK_FP(0x0000,0x0202));
int get_screen_text( char *buffer, int max_len )
{
  int i, c;
  char sr, sc;
  uchar far *s;

  if( *Lstat != 1 )
    return(-1);

  sr = *Lrow, sc = *Lcol;
  s = Screen + (sr * 160) + (sc * 2);
  for( c = sc; (c > 0) && !isspace(*s); c-- )
      s -= 2;
  if( isspace(*s) )
    s += 2;
  for( i = 0; (i < max_len) && (isalnum(*s) || (*s == '_')); i++, s += 2 )
    *buffer++ = *s;
  *buffer = '\0';
  return(i);
}
/*** end of get_screen_text ***/

/***************/
/* ~abort_help */
/*             **************************************************************/
/****************************************************************************/
void abort_help( void )
{
  puts("Invalid arguments - usage: enqhelp [filename get_mode search_str sx sy ex ey]\r");
  puts("where sx-ey are optional parameters specifying a window\r");
  puts("where the width must be 64 or greater if the heigth is less\r");
  puts("than 14, and the minimum width is 40, the minimum heigth is 10,\r");
  puts("and get_mode is 1 if the screen should be read for a keyword,\r");
  puts("otherwise the search_str is used.  Use a search_str of 0 for no search.\r");
  exit(0);
}
/*** end of abort_help ***/

/********************/
/* ~init_help_video */
/*                  *********************************************************/
/****************************************************************************/
void init_help_video( void )
{
  get_v_mode();
  V_cols = 80;
  V_rows = get_num_rows();
  Font_rows = Font_spacing = 8; 
  check_desq();
  Screen = (uchar UW_FAR *) (UW_MK_FP(DV_seg, DV_off));
}
/*** end of init_help_video ***/

/**** END OF FILE ****/
