/****************************************************************************/
/*                                                                          */
/* UW_GLOB.H                                                                */
/*                                                                          */
/* This module contains all the globals used by the UltraWIN library.       */
/*                                                                          */
/*                                                          Kevin Huck      */
/*                                                          Boyd Gafford    */
/*                                                                          */
/****************************************************************************/
#ifndef __UW_GLOB_H
#define __UW_GLOB_H
#include <conio.h>

uchar UW_FAR  *Screen;                  /* pointer to physical screen loc   */

int           Num_windows;              /* number of open windows on desk!  */
int           V_cols;                   /* columns on the video screen      */
int           V_rows;                   /* rows on the video screen         */
int           V_mode = -1;              /* old video mode, init to -1       */

int           DV_seg;                   /* Desqview variables               */
int           DV_off;
int           DV_flag;
int           DV_upd;
                                         
uchar         Dflt_att = (RED << 4) | YELLOW;
uchar         Dflt_bdr_att = (RED << 4) | WHITE;

int           Stack[64];
int           Stack_ptr;                /* stack to save wn states          */
int           Csr_visible;              /* is the cursor visible            */
int           Csr_in_use;               /* is the cursor used by a popup?   */
char          Hide_entry_mask = '*';    /* the mask for passwords, etc      */
EVENT         Event;                    /* the global event variable        */
int           Mouse_exists;             /* is the mouse available or not?   */

WINDOW        *First_window;            /* manager first window pointer     */
WINDOW        *Last_window;             /* manager last window pointer      */

int (*Idle_func)(void);                 /* global function pointer          */
int (*Key_func)(int, int);              /* background key function pointer  */
                                        /* validation function pointer      */
int (*Vld_func)(char*, char*, char*, int, int, WINDOW*);
                                        /* gets hook function pointer       */
int (*Gets_hook_func)(char*, char*, char*, int, int, int, EVENT*, WINDOW*);

void (*Graphic_func)(int, int, uchar);  /* single char output function      */
uchar         Fgnd, Bkgnd;              /* fore/background for graphics mode*/
int           X_res, Y_res;             /* x, y, res for graphics mode      */
int           Font_rows, Font_spacing;  /* rows in font, font spacing       */
int           Gseg, Goff;               /* graphics screen segment, offset  */
int           Bytes_per_row;            /* bytes per graphics row           */
int           Ega, Vga, EgaVga;         /* 1 if present (mutually exclusive)*/
int           G_csrx, G_csry;
int           G_csr_char, G_opt;
PRINT         *Printers[MAX_PRINTERS];  /* printer queue structure pointers */

volatile int  Uw_timers[4];             /* user timers - decrement to 0     */
volatile int  Sys_timers[2];
volatile int  Sound_timer;              /* system/sound timers              */
int           Clock_init;               /* 1 if we have clock vector        */
int           Sound_on;                 /* 1 when sound is on               */
ulong         Tics;                     /* total clock interrupts           */
int           Tics_per_sec;             /* clock tics per second            */  
int           Video_init;               /* 1 if we have init'd video (V2.5) */
int           Mouse_init;               /* 1 if we have init'd mouse (V2.5) */

int           Dbg_log_on = 1, Dbg_stack_on = 1;   /* internal debug support */
int           Dbg_line;
char         *Dbg_file = "?";

#endif /* __UW_GLOB_H */

/**** END OF FILE ****/
